using System.Collections.ObjectModel;

namespace EnergyDataModels
{
    public class EnergyProductionDataSample : EnergyProductionData
    {
        public EnergyProductionDataSample()
        {
            this.Add(new EnergyProduction { Region = "America", Country = "Canada", XCoal = 400, Coal = double.NaN, Oil = 100, Gas = 175, Nuclear = 225, Hydro = 350 });
            this.Add(new EnergyProduction { Region = "Asia", Country = "China", XCoal = 925, Coal = 925, Oil = 200, Gas = 350, Nuclear = 400, Hydro = 625 });
            this.Add(new EnergyProduction { Region = "Europe", Country = "Russia", XCoal = 550, Coal = 550, Oil = 200, Gas = 250, Nuclear = 475, Hydro = 425 });
            this.Add(new EnergyProduction { Region = "Asia", Country = "Australia", XCoal = 350, Coal = 350, Oil = 100, Gas = 150, Nuclear = 175, Hydro = 350 });
            this.Add(new EnergyProduction { Region = "America", Country = "United States", XCoal = 800,Coal = 800, Oil = 250, Gas = 475, Nuclear = 575, Hydro = 750 });
            this.Add(new EnergyProduction { Region = "Europe", Country = "France", XCoal = 275, Coal = double.NaN, Oil = 150, Gas = 350, Nuclear = 275, Hydro = 325 });
        }
    }
    public class EnergyProductionDataHistory : EnergyProductionData
    {
        public EnergyProductionDataHistory()
        {
            this.Add(new EnergyProduction { Year = "2000", Country = "Canada", Coal = double.NaN, XCoal = 400, Oil = 100, Gas = 175, Nuclear = 225, Hydro = 350 });
            this.Add(new EnergyProduction { Year = "2010", Country = "Canada", Coal = double.NaN, XCoal = 425, Oil = 150, Gas = 225, Nuclear = 255, Hydro = 400 });
            this.Add(new EnergyProduction { Year = "2020", Country = "Canada", Coal = double.NaN, XCoal = 475, Oil = 200, Gas = 275, Nuclear = 325, Hydro = 450 });

            this.Add(new EnergyProduction { Year = "2000", Country = "China", Coal = 825, XCoal = 825, Oil = 200, Gas = 350, Nuclear = 400, Hydro = 625 });
            this.Add(new EnergyProduction { Year = "2010", Country = "China", Coal = 925, XCoal = 925, Oil = 250, Gas = 400, Nuclear = 420, Hydro = 685 });
            this.Add(new EnergyProduction { Year = "2020", Country = "China", Coal = 975, XCoal = 975, Oil = 300, Gas = 450, Nuclear = 450, Hydro = 725 });

            this.Add(new EnergyProduction { Year = "2000", Country = "Russia", Coal = 550, XCoal = 550, Oil = 200, Gas = 250, Nuclear = 500, Hydro = 425 });
            this.Add(new EnergyProduction { Year = "2010", Country = "Russia", Coal = 600, XCoal = 600, Oil = 220, Gas = 280, Nuclear = 525, Hydro = 485 });
            this.Add(new EnergyProduction { Year = "2020", Country = "Russia", Coal = 650, XCoal = 650, Oil = 250, Gas = 350, Nuclear = 575, Hydro = 525 });

            this.Add(new EnergyProduction { Year = "2000", Country = "Australia", Coal = 450, XCoal = 450, Oil = 100, Gas = 150, Nuclear = 175, Hydro = 350 });
            this.Add(new EnergyProduction { Year = "2010", Country = "Australia", Coal = 480, XCoal = 480, Oil = 120, Gas = 250, Nuclear = 225, Hydro = 400 });
            this.Add(new EnergyProduction { Year = "2020", Country = "Australia", Coal = 550, XCoal = 550, Oil = 180, Gas = 350, Nuclear = 275, Hydro = 450 });

            this.Add(new EnergyProduction { Year = "2000", Country = "United States", Coal = 800, XCoal = 800, Oil = 250, Gas = 475, Nuclear = 575, Hydro = 750 });
            this.Add(new EnergyProduction { Year = "2010", Country = "United States", Coal = 850, XCoal = 850, Oil = 300, Gas = 525, Nuclear = 625, Hydro = 800 });
            this.Add(new EnergyProduction { Year = "2020", Country = "United States", Coal = 900, XCoal = 900, Oil = 350, Gas = 575, Nuclear = 675, Hydro = 850 });

            this.Add(new EnergyProduction { Year = "2000", Country = "France", Coal = double.NaN, XCoal = 400, Oil = 150, Gas = 350, Nuclear = 275, Hydro = 325 });
            this.Add(new EnergyProduction { Year = "2010", Country = "France", Coal = double.NaN, XCoal = 625, Oil = 200, Gas = 400, Nuclear = 325, Hydro = 385 });
            this.Add(new EnergyProduction { Year = "2020", Country = "France", Coal = double.NaN, XCoal = 675, Oil = 250, Gas = 450, Nuclear = 375, Hydro = 425 });
        }
    }
    public class EnergyProductionData : ObservableCollection<EnergyProduction>
    {

    }
    public class EnergyProduction
    {

        public string Country { get; set; }
        public string Region { get; set; }
        public string Year { get; set; }

        // Non-Renewable Energy Sources
        private double _nuclear;
        public double Nuclear { get { return _nuclear; } set { _nuclear = value; } }      

        private double _coal;
        public double Coal { get { return _coal; } set { _coal = value; } }

        private double _xcoal;
        public double XCoal { get { return _xcoal; } set { _xcoal = value; } }   

        private double _oil;
        public double Oil { get { return _oil; } set { _oil = value;  } }     

        private double _gas;
        public double Gas { get { return _gas; } set { _gas = value; } }
       
        // Renewable Energy Sources
        private double _hydro;
        public double Hydro { get { return _hydro; } set { _hydro = value;  } }
      
    }   

}